---
title: RTCPeerConnection.ontrack
slug: Web/API/RTCPeerConnection/ontrack
tags:
  - Event Handler
  - Experimental
  - Property
  - RTCPeerConnection
  - Reference
  - WebRTC
  - ontrack
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The {{domxref("RTCPeerConnection")}} property <strong><code>ontrack</code></strong> is an {{domxref("EventHandler")}} which specifies a function to be called when the {{event("track")}} event occurs, indicating that a track has been added to the {{domxref("RTCPeerConnection")}}.</span> The function receives as input the event object, of type {{domxref("RTCTrackEvent")}}; this event is sent when a new incoming {{domxref("MediaStreamTrack")}} has been created and associated with an {{domxref("RTCRtpReceiver")}} object which has been added to the set of receivers on connection.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>RTCPeerConnection</em>.ontrack = <em>eventHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>Set <code>ontrack</code> to be a function you provide that accepts as input a {{domxref("RTCTrackEvent")}} object describing the new track and how it's being used. This information includes the {{domxref("MediaStreamTrack")}} object representing the new track, the {{domxref("RTCRtpReceiver")}} and {{domxref("RTCRtpTransceiver")}}, and a list of {{domxref("MediaStream")}} objects which indicates which stream or streams the track is part of..</p>

<h2 id="Example">Example</h2>

<p>This example, taken from the code for the article <a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a>, connects the incoming track to the {{HTMLElement("video")}} element which will be used to display the incoming video.</p>

<pre class="brush: js">pc.ontrack = function(event) {
  document.getElementById("received_video").srcObject = event.streams[0];
  document.getElementById("hangup-button").disabled = false;
};
</pre>

<p>The first line of our <code>ontrack</code> event handler takes the first stream in the incoming track and sets the {{htmlattrxref("srcObject", "video")}} attribute to that. This connects that stream of video to the element so that it begins to be presented to the user. The second line of code enables a "hang up" button, which the user can use to disconnect from the call.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-ontrack', 'RTCPeerConnection.ontrack')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.ontrack")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{event("track")}} event and its type, {{domxref("RTCTrackEvent")}}.</li>
</ul>
